Index: /trunk/gli/src/org/greenstone/gatherer/cdm/CollectionMeta.java
===================================================================
--- /trunk/gli/src/org/greenstone/gatherer/cdm/CollectionMeta.java	(revision 4931)
+++ /trunk/gli/src/org/greenstone/gatherer/cdm/CollectionMeta.java	(revision 4932)
@@ -6,13 +6,7 @@
  * University of Waikato, New Zealand.
  *
- * <BR><BR>
- *
  * Author: John Thompson, Greenstone Digital Library, University of Waikato
  *
- * <BR><BR>
- *
  * Copyright (C) 1999 New Zealand Digital Library Project
- *
- * <BR><BR>
  *
  * This program is free software; you can redistribute it and/or modify
@@ -21,12 +15,8 @@
  * (at your option) any later version.
  *
- * <BR><BR>
- *
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
- *
- * <BR><BR>
  *
  * You should have received a copy of the GNU General Public License
@@ -35,137 +25,117 @@
  *########################################################################
  */
-
- 
-
-
-
-
-/* GPL_HEADER */
 package org.greenstone.gatherer.cdm;
 /**************************************************************************************
- * Title:        Gatherer
- * Description:  The Gatherer: a tool for gathering and enriching a digital collection.
- * Copyright:    Copyright (c) 2001
- * Company:      The University of Waikato
- * Written:        /05/02
- * Revised:      22/08/02 Revamped, Optimized and Commented.
+ * Written:     
+ * Revised:     28/06/03 - DOM support
  **************************************************************************************/
+import org.greenstone.gatherer.Configuration;
+import org.greenstone.gatherer.Gatherer;
+import org.greenstone.gatherer.cdm.CollectionConfiguration;
+import org.greenstone.gatherer.cdm.CollectionDesignManager;
+import org.greenstone.gatherer.cdm.DOMProxyListEntry;
 import org.greenstone.gatherer.cdm.Index;
-import org.greenstone.gatherer.cdm.Language;
+import org.greenstone.gatherer.msm.MSMUtils;
+import org.greenstone.gatherer.util.StaticStrings;
 import org.greenstone.gatherer.util.Utility;
+import org.w3c.dom.*;
 /** This class encapsulates a single collection level metadata assignment, which constitutes a name, language and value.
  * @author John Thompson, Greenstone Digital Library, University of Waikato
- * @version 2.3
+ * @version 2.4
  */
 public class CollectionMeta
-    implements Comparable {
-    /** A reference to the collection design manager for access to the language manager. */
-    private CollectionDesignManager manager = null;
-    /** The language of this metadata. Should be a two letter code. */
-    private Language language = null;
-    /** The name of the thing this metadata is assigned to, which may also refer to an Index or a Partition. */
-    private Object name = null;
-    /** The value of this metadata. */
-    private String value = null;
+    implements DOMProxyListEntry {
+    private Element element;
+    private String text;
+
     /** Constructor.
-     * @param name The object the metadata is assigned to as an <strong>Object</strong>.
-     * @param language The language of the metadata as a <strong>Language</strong>. Should be a two letter code.
-     * @param value The value of this metadata, as a <strong>String</strong>.
-	  */
-    public CollectionMeta(CollectionDesignManager manager, Object name, Language language, String value) {
-	this.language = language;
-	this.manager = manager;
-	this.name = name;
-	this.value = value;
+     * @param element the Element from which we will determine metadata details
+     */
+    public CollectionMeta(Element element) {
+	this.element = element;
     }
+
+    /** Constructor to create a new piece of metadata given its name. */
+    public CollectionMeta(String name) {
+	element = CollectionDesignManager.collect_config.document.createElement(StaticStrings.COLLECTIONMETADATA_ELEMENT);
+	element.setAttribute(StaticStrings.NAME_ATTRIBUTE, name);
+	element.setAttribute(StaticStrings.LANGUAGE_ATTRIBUTE, Gatherer.config.interface_language);
+    }
+
+    /** Constructor to create a new piece of metadata given its name. */
+    public CollectionMeta(String name, String language) {
+	element = CollectionDesignManager.collect_config.document.createElement(StaticStrings.COLLECTIONMETADATA_ELEMENT);
+	element.setAttribute(StaticStrings.NAME_ATTRIBUTE, name);
+	element.setAttribute(StaticStrings.LANGUAGE_ATTRIBUTE, language);
+    }
+
     /** Method to compare two collection metadata objects to calculate their respective ordering.
-	  * @param object The other metadata to compare to, as an <strong>Object</strong>.
-	  * @return An <i>int</i> which is less than 0 if this object proceeds the given object, 0 if they are equal and greater than 0 otherwise.
-	  * @see org.greenstone.gatherer.cdm.Language
-	  */
+     * @param object the other metadata to compare to, as an Object
+     * @return an int which is less than 0 if this object proceeds the given object, 0 if they are equal and greater than 0 otherwise.
+     * @see org.greenstone.gatherer.cdm.Language
+     */
     public int compareTo(Object object) {
-	if(object instanceof CollectionMeta) {
-	    CollectionMeta metadata = (CollectionMeta) object;
-	    int result = name.toString().compareTo(metadata.getName().toString());
-	    if(result == 0) {
-		Language other_language = metadata.getLanguage();
-		if(language != null && other_language != null) {
-		    result = language.compareTo(metadata.getLanguage());
-		    if(result == 0) {
-			return value.compareTo(metadata.getValue());
-		    }
-		}
-		else if(language != null) {
-		    return -1;
-		}
-		else if(other_language != null) {
-		    return 1;
-		}
-	    }
-	    return result;
-	}
 	return toString().compareTo(object.toString());
     }
+
+    /** Factory constructor. */
+    public DOMProxyListEntry create(Element element) {
+	return new CollectionMeta(element);
+    }
+
     /** Method to compare two collection metadata objects for equality.
-	  * @param object The other metadata to compare to, as an <strong>Object</strong>.
-	  * @return A <i>boolean</i> value of <i>true</i> if the object are equal, <i>false</i> otherwise.
-	  */
+     * @param object The other metadata to compare to, as an <strong>Object</strong>.
+     * @return A <i>boolean</i> value of <i>true</i> if the object are equal, <i>false</i> otherwise.
+     */
     public boolean equals(Object object) {
-	if(compareTo(object) == 0) {
-	    return true;
-	}
-	return false;
+	return (compareTo(object) == 0);
     }
+
+    public Element getElement() {
+	return element;
+    }
+
     /** Method to retrieve the value of language.
-     * @return The value of language as a <strong>Language</strong>.
+     * @return The value of language as a <strong>String</strong>.
      */
-    public Language getLanguage() {
-	return language;
+    public String getLanguage() {
+	// Retrieve the language string
+	return element.getAttribute(StaticStrings.LANGUAGE_ATTRIBUTE);
     }
+
     /** Method to retrieve the value of name.
-     * @return The value of name as an <strong>Object</strong>.
+     * @return 
      */
-    public Object getName() {
-	return name;
+    public String getName() {
+	return element.getAttribute(StaticStrings.NAME_ATTRIBUTE);
     }
     /** Method to retrieve the value of value (well great choice of name there).
-	  * @return The value of value as a <strong>String</strong>.
-	  */
+     * @return The value of value as a <strong>String</strong>.
+     */
     public String getValue() {
-	return value;
+	// We have to replace the string made of '\' 'n' with the '\n' character! Also watch for other greenstone magic
+	return Utility.decodeGreenstone(MSMUtils.getValue(element));
     }
-    /** Method to print out this class as it would appear within the collection configuration file.
-	  * @return A <strong>String</strong> containing the text value of this class.
-	  */
-    public String toString() {
-	String text = "collectionmeta ";
-	if(name instanceof Index) {
-	    text = text + ".";
-	    Index index = (Index)name;
-	    text = text + index.toStringConfig() + " ";
+
+    public boolean isAssigned() {
+	return (element != null && !element.getAttribute(CollectionConfiguration.ASSIGNED_ATTRIBUTE).equals(CollectionConfiguration.FALSE_STR));
+    }
+
+    /** Determine if this metadata is one of the four special pieces of metadata.
+     * @return true if this metadata is special, false otherwise.
+     */
+    public boolean isSpecial() {
+	return (element != null && element.getAttribute(StaticStrings.SPECIAL_ATTRIBUTE).equals(StaticStrings.TRUE_STR));
+    }
+
+    public void setAssigned(boolean assigned) {
+	if(element != null) {
+	    element.setAttribute(CollectionConfiguration.ASSIGNED_ATTRIBUTE, (assigned ? CollectionConfiguration.TRUE_STR : CollectionConfiguration.FALSE_STR));
 	}
-	else if(name instanceof SubIndex) {
-	    text = text + ".";
-	    SubIndex index = (SubIndex)name;
-	    text = text + index.toString() + " ";
-	}
-	else {
-	    text = text + name.toString() + " ";
-	}
-	if(language != null && manager.languages.size() > 0 && !manager.languages.isDefaultLanguage(language)) {
-	    text = text + "[l=" + language.getCode() + "] ";
-	}
-	text = text + "\"" + Utility.encodeGreenstone(value) + "\"\n";
-	return text;
     }
-    /** Used to update the contents of this collection level metadata to the given 'new' values.
-	  * @param name The new name of the metadata, as a <strong>Object</strong>.
-	  * @param language The new <strong>Language</strong> of the metadata.
-	  * @param value And the value the metadata is assigned, as a <strong>String</strong>.
-	  */
-    public void update(Object name, Language language, String value) {
-	this.name = name;
-	this.language = language;
-	this.value = value;
+
+    public void setElement(Element element) {
+	this.element = element;
+	text = null;
     }
 
@@ -174,12 +144,16 @@
      */
     public void setValue(String value) {
-	this.value = value;
+	MSMUtils.setValue(element, Utility.encodeGreenstone(value));
+	text = null; // Reset text
     }
 
-    /** Ensure this is a valid metadata entry by checking that the value is non-null and non-zero length (after having removed whitespace).
-     * @return <i>true</i> if this metadata has a valid value and should be added to the config, <i>false</i> otherwise.
-     */
-    public boolean valid() {
-	return(value != null && value.trim().length() > 0);
+    /** Method to print out this class as it would appear within the collection configuration file.
+	  * @return A <strong>String</strong> containing the text value of this class.
+	  */
+    public String toString() {
+	if(text == null) {
+	    text = CollectionConfiguration.toString(element, true);
+	}
+	return text;
     }
 }
Index: /trunk/gli/src/org/greenstone/gatherer/cdm/CollectionMetaManager.java
===================================================================
--- /trunk/gli/src/org/greenstone/gatherer/cdm/CollectionMetaManager.java	(revision 4931)
+++ /trunk/gli/src/org/greenstone/gatherer/cdm/CollectionMetaManager.java	(revision 4932)
@@ -6,13 +6,7 @@
  * University of Waikato, New Zealand.
  *
- * <BR><BR>
- *
  * Author: John Thompson, Greenstone Digital Library, University of Waikato
  *
- * <BR><BR>
- *
  * Copyright (C) 1999 New Zealand Digital Library Project
- *
- * <BR><BR>
  *
  * This program is free software; you can redistribute it and/or modify
@@ -21,12 +15,8 @@
  * (at your option) any later version.
  *
- * <BR><BR>
- *
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
- *
- * <BR><BR>
  *
  * You should have received a copy of the GNU General Public License
@@ -35,20 +25,5 @@
  *########################################################################
  */
-
- 
-
-
-
-
-/* GPL_HEADER */
 package org.greenstone.gatherer.cdm;
-/**************************************************************************************
- * Title:        Gatherer
- * Description:  The Gatherer: a tool for gathering and enriching a digital collection.
- * Copyright:    Copyright (c) 2001
- * Company:      The University of Waikato
- * Written:        /05/02
- * Revised:      22/08/02 Revamped, Optimized and Commented.
- **************************************************************************************/
 import java.awt.*;
 import java.awt.event.*;
@@ -59,111 +34,60 @@
 import org.greenstone.gatherer.cdm.CollectionDesignManager;
 import org.greenstone.gatherer.cdm.CollectionMeta;
+import org.greenstone.gatherer.cdm.DOMProxyListModel;
 import org.greenstone.gatherer.cdm.Index;
-import org.greenstone.gatherer.cdm.Language;
 import org.greenstone.gatherer.gui.EditorDialog;
+import org.greenstone.gatherer.util.StaticStrings;
 import org.greenstone.gatherer.util.Utility;
+import org.w3c.dom.*;
 /** This class is responsible for maintaining a list of assigned collection level metadata, and for allows manipulations on the aforementioned data.
  * @author John Thompson, Greenstone Digital Library, University of Waikato
- * @version 2.3
+ * @version 2.3d
  */
-// ####################################################################################
-// Optimization                               Saving
-// ####################################################################################
-// Removed Vector and Hashtable               + Memory, + Processor
-// ####################################################################################
-public class CollectionMetaManager
-    extends DefaultListModel {
-    /** A reference to the cdm manager so we can access indexes and languages. */
-    private CollectionDesignManager manager = null;
-    /** A reference to ourself so that inner classes can use us as a model. */
-    private DefaultListModel model = null;
-    /** A reference to the Gatherer. */
-    private Gatherer gatherer = null;
-    /** The language the most recent metadata returned was in. */
-    private Language current_language = null;
-    /** We can't safely parse metadata commands until after all the other commands have been parsed, so we store commands here for now. */
-    private ArrayList unresolved_commands = null;
-    /** Constructor.
-     * @param gatherer A reference to the <strong>Gatherer</strong>.
-     * @param manager A reference to the <strong>CollectionDesignManager</strong> for access to other configuration managers.
-     */
-    public CollectionMetaManager(Gatherer gatherer, CollectionDesignManager manager) {
-	super();
-	this.gatherer = gatherer;
-	this.manager = manager;
-	this.model = this;
-	this.unresolved_commands = new ArrayList();
+public class CollectionMetaManager 
+    extends DOMProxyListModel {
+    
+    /** Constructor. */
+    public CollectionMetaManager() {
+	super(CollectionDesignManager.collect_config.getDocumentElement(), StaticStrings.COLLECTIONMETADATA_ELEMENT, new CollectionMeta(""));
+	Gatherer.println("CollectionMetaManager: " + getSize() + " metadata parsed.");
     }
     /** Method to add a new piece of metadata.
-	  * @param metadata The new <strong>CollectionMeta</strong>.
-	  */
-    public void addMetadata(CollectionMeta metadata) {
-	CollectionMeta existing = getMetadata(metadata.getName().toString(), metadata.getLanguage(), false);
-	if(existing != null) {
-	    removeElement(existing);
+     * @param metadata the new CollectionMeta
+     */
+    public void addMetadatum(CollectionMeta metadata) {
+	if(!contains(metadata)) {
+	    Element element = metadata.getElement();
+	    // Locate where we should insert this new subcollection. 
+	    Node target_node = CollectionConfiguration.findInsertionPoint(element);
+	    // Failing that we insert immediately after a language string
+	    add(root, metadata, target_node);
+	    Gatherer.c_man.configurationChanged();
 	}
-	addElement(metadata);
-	gatherer.c_man.configurationChanged();
+	Gatherer.c_man.configurationChanged();
     }
-    /** Retrieve the collectionextra metadata in the default language, if present.
-	  * @return A <strong>CollectionMeta</strong> containing the collectionextra in the default language if present, or else the first collectionextra of any language, otherwise <i>null</i>.
-	  * @see org.greenstone.gatherer.cdm.Language
-	  */
-    public CollectionMeta getCollectionExtra() {
-	CollectionMeta result = getMetadata("collectionextra", Gatherer.config.interface_language, true);
-	if(result == null) {
-	    result = new CollectionMeta(manager, "collectionextra", Gatherer.config.interface_language, "");
-	    addMetadata(result);
+
+    public CollectionMeta get(int i) {
+	return (CollectionMeta) getElementAt(i);
+    }
+
+    /** Retrieve all of the general metadata. */
+    public ArrayList getMetadata() {
+	ArrayList result = new ArrayList();
+	int size = getSize();
+	for(int i = 0; i < size; i++) {
+	    CollectionMeta metadata = (CollectionMeta) getElementAt(i);
+	    if(!metadata.getName().startsWith(StaticStrings.STOP_CHARACTER)) {
+		result.add(metadata);
+	    }
 	}
 	return result;
     }
-    /** Retrieve the collectionname metadata in the default language, if present.
-	  * @return A <strong>CollectionMeta</strong> containing the collectionname in the default language if present, or else the first collectionname of any language, otherwise <i>null</i>.
-	  * @see org.greenstone.gatherer.cdm.Language
-	  */
-    public CollectionMeta getCollectionName() {
-	return getMetadata("collectionname", Gatherer.config.interface_language, true);
-    }
-    /** Retrieve the iconcollection metadata in the default language, if present.
-	  * @return A <strong>CollectionMeta</strong> containing the iconcollection in the default language if present, or else the first iconcollection of any language, otherwise <i>null</i>.
-	  * @see org.greenstone.gatherer.cdm.Language
-	  */
-    public CollectionMeta getIconCollection() {
-	CollectionMeta result = getMetadata("iconcollection", Gatherer.config.interface_language, true);
-	if(result == null) {
-	    result = new CollectionMeta(manager, "iconcollection", Gatherer.config.interface_language, "");
-	    addMetadata(result);
-	}
-	return result;
-    }
-    /** Retrieve the iconcollection metadata in the default language, if present.
-	  * @return A <strong>CollectionMeta</strong> containing the iconcollectionsmall in the default language if present, or else the first iconcollectionsmall of any language, otherwise <i>null</i>.
-	  * @see org.greenstone.gatherer.cdm.Language
-	  */
-    public CollectionMeta getIconCollectionSmall() {
-	CollectionMeta result = getMetadata("iconcollectionsmall", Gatherer.config.interface_language, true);
-	if(result == null) {
-	    result = new CollectionMeta(manager, "iconcollectionsmall", Gatherer.config.interface_language, "");
-	    addMetadata(result);
-	}
-	return result;
-    }
-    /** Method to retrieve the list of metadata.
-	  * @return An <strong>ArrayList</strong> containing the metadata.
-	  */
-    public ArrayList getMetadata() {
-	ArrayList metadata = new ArrayList();
-	for(int i = 0; i < size(); i++) {
-	    metadata.add(get(i));
-	}
-	Collections.sort(metadata);
-	return metadata;
-    }
 	 
     /** Retrieve all of the metadata for the given feature, regardless of language. */
-    public ArrayList getMetadata(Object name) {
+    public ArrayList getMetadata(String name) {
 	ArrayList result = new ArrayList();
-	for(int i = 0; i < size(); i++) {
-	    CollectionMeta metadata = (CollectionMeta) get(i);
+	int size = getSize(); // Refresh DOM Model
+	for(int i = 0; i < size; i++) {
+	    CollectionMeta metadata = (CollectionMeta) getElementAt(i);
 	    if(metadata.getName().equals(name)) {
 		result.add(metadata);
@@ -172,24 +96,51 @@
 	return result;
     }
+
+    /** Retrieve the named piece of metadata, in the default language, if available. If no such metadata is available then it is created.
+     * @param name the name of the metadatum to retrieve as a String
+     * @return the dom Element containing the specified metadatum
+     */
+    public CollectionMeta getMetadatum(String name) {
+	return getMetadatum(name, true);
+    }
+
+    public CollectionMeta getMetadatum(String name, boolean add_if_not_found) {
+	///atherer.println("Get the metadata for " + name + " in the default language.");
+	int size = getSize();
+	for(int i = 0; i < size; i++) {
+	    CollectionMeta metadatum = (CollectionMeta) getElementAt(i);
+	    if(metadatum.getName().equals(name) && metadatum.getLanguage().equals(Gatherer.config.interface_language)) {
+		///atherer.println("Found '" + metadatum + "'");
+		return metadatum;
+	    }
+	    else {
+		///atherer.println("No match with: " + metadatum.getName() + " [l=" + metadatum.getLanguage() + "] \"" + metadatum.getValue() + "\"");
+	    }
+	    metadatum = null;
+	}
+	if(add_if_not_found) {
+	    CollectionMeta result = new CollectionMeta(name);
+	    addMetadatum(result);
+	    ///atherer.println("Added new metadata.");
+	    return result;
+	}
+	else {
+	    return null;
+	}
+    }
+
     /** Method to retrieve a certain piece of metadata based on its name and language.
-	  * @param name the name of the metadata as an Object (as it may actually be a refernce to an Index or SubIndex)
-	  * @param language The <strong>Language</strong> of the metadata.
-	  * @param partial <i>true</i> to return the first partial match (ie matches name but not language).
-	  * @return The <strong>CollectionMeta</strong> requested, or <i>null</i> if no such metadata.
-	  */
-    public CollectionMeta getMetadata(Object name, Language language, boolean partial) { 
+     * @param name the name of the metadata as an Object (as it may actually be a refernce to an Index or SubIndex)
+     * @param language the language of the metadata.
+     * @param partial <i>true</i> to return the first partial match (ie matches name but not language).
+     * @return The <strong>CollectionMeta</strong> requested, or <i>null</i> if no such metadata.
+     */
+    public CollectionMeta getMetadata(String name, String language, boolean partial) { 
 	CollectionMeta partial_match = null;
-	for(int i = 0; i < size(); i++) {
-	    CollectionMeta metadata = (CollectionMeta) get(i);
+	for(int i = 0; i < getSize(); i++) {
+	    CollectionMeta metadata = (CollectionMeta) getElementAt(i);
 	    Object metadata_name = metadata.getName();
 	    // We test the case of an object match (ie Index to Index)...
 	    if(metadata_name.equals(name)) {
-		if (metadata.getLanguage().equals(language)) {
-		    return metadata;
-		}
-		partial_match = metadata;
-	    }
-	    // But if that fails we also try a string match such that "section:dls.Title" == Index
-	    if(metadata_name.toString().equals(name.toString())) {
 		if (metadata.getLanguage().equals(language)) {
 		    return metadata;
@@ -203,179 +154,44 @@
 	return null;
     }
-    /** Method that attempts to parse a collection metadata command from the given text. If a command is parsed successfully it is immediately added to the the collections metadata.
-	 * @param command The command text we wish to parse, as a <strong>String</strong>.
-	 * @return A <i>boolean</i> which is <i>true</i> if a collection metadata command was successfully parsed, <i>false</i> otherwise.
-	 * @see org.greenstone.gatherer.cdm.CollectionDesignManager
-	 * @see org.greenstone.gatherer.cdm.CommandTokenizer
-	 * @see org.greenstone.gatherer.cdm.Language
-	 * @see org.greenstone.gatherer.cdm.LanguageManager
-	 * @see org.greenstone.gatherer.util.Utility
-	 */
-    public boolean parse(String command, boolean finished) {
-	String temp = command.toLowerCase();
-	if(temp.startsWith("collectionmeta")) {
-	    if(finished) {
-		CommandTokenizer ct = new CommandTokenizer(command);
-		if(ct.countTokens() >= 3) {
-		    ct.nextToken(); // Throw away collectionmeta
-		    Object key = ct.nextToken();
-		    Language language = null;
-		    String language_code = null;
-		    String value = ct.nextToken();
-		    // Arg. Remember a language token will be '[l=<code>]'
-		    if(value.startsWith("[") && value.endsWith("]")) {
-			language_code = value.substring(3, value.length() - 1);
-			///ystem.err.println("Language code = " + language_code);
-			value = ct.nextToken();
-		    }
-		    // Check if the key is an index, and if so retrieve it.
-		    if(((String)key).startsWith(".")) {
-			///ystem.err.println("Detected '.' prefix.");
-			String key_str = (String)key;
-			key = null;
-			key_str = key_str.substring(1);
-			Index ind = Index.parseIndexConfig(key_str, manager);
-			if (ind != null) {
-			    
-			    key = manager.indexes.getIndex(ind.toString(false));
-			}
-			
-			// If that didn't work, then it might be a subindex so have a bash at retrieving that instead.
-			if(key == null) {
-			    key = manager.subcollections.getSubIndex(key_str);
-			    //if(key != null) {
-				///ystem.err.println("Its a subindex.");
-			    //}
-			    //else {
-				///ystem.err.println("Error Will Robinson.");
-			    //}
-			}
-			//else {
-			    ///ystem.err.println("Its an index.");
-			//}
-		    }
-		    // An if we have a language code, retrieve its object too.
-		    if(language_code != null) {
-			language = manager.languages.getLanguage(language_code, false);
-		    }
-		    // Otherwise set language to the default language.
-		    else {
-			language = Gatherer.config.interface_language;
-		    }
-		    if(key != null) {
-			// Trim any "
-			if(value.equals("\"\"")) {
-			    value = "";
-			}
-			else {
-			    if(value.startsWith("\"")) {
-				value = value.substring(1);
-			    }
-			    if(value.endsWith("\"")) {
-				value = value.substring(0, value.length() - 1);
-			    }
-			}
-			CollectionMeta meta = new CollectionMeta(manager, key, language, Utility.decodeGreenstone(value));
-			addMetadata(meta);
-		    }
-		    return true;
+
+    /** Method to remove a piece of metadata.
+     * @param metadata metadata
+     */
+    public void removeMetadata(CollectionMeta metadata) {
+	if(metadata != null) {
+	    String name = metadata.getName();
+	    String language = metadata.getLanguage();
+	    for(int i = 0; i < getSize(); i++) {
+		CollectionMeta other = (CollectionMeta) getElementAt(i);
+		if(name.equals(other.getName()) && language.equals(other.getLanguage())) {
+		    remove(i);
+		    Gatherer.c_man.configurationChanged();
+		    return;
 		}
-	    }
-	    else {
-		unresolved_commands.add(command);
-		return true;
-	    }
+		other = null;
+	    }	
+	    language = null;
+	    name = null;
 	}
-	return false;
-    }
-    /** Ensure that the values being showed are the most up to date. */
-    public void refresh() {
-	fireContentsChanged(this, 0, size());
     }
 
-    /** Method to remove a piece of metadata.
-	  * @param metadata The <strong>CollectionMeta</strong> you wish to remove.
-	  */
-    public void removeMetadata(CollectionMeta metadata) {
-	removeElement(metadata);
-	gatherer.c_man.configurationChanged();
-    }
-    /** Method which attempts to reparse obvious metadata commands which used unresovable references.
-	  */
-    public void reparseUnresolved() {
-	for(int i = 0; i < unresolved_commands.size(); i++) {
-	    parse((String)unresolved_commands.get(i), true);
+    /** Removes all of the metadata with a certain name, regardless of language or value. */
+    public void removeMetadata(String name) {
+	boolean removed_entry = false;
+	for(int i = getSize(); i != 0; i--) {
+	    CollectionMeta other = (CollectionMeta) getElementAt(i - 1);
+	    if(name.equals(other.getName())) {
+		remove(i - 1);
+		removed_entry = true;
+	    }
+	    other = null;
+	}	
+	if(removed_entry) {
+	    Gatherer.c_man.configurationChanged();
 	}
-	// Regardless of if they work, clear the commands.
-	unresolved_commands.clear();
-    }
-    /** Sets the value of a certain metadata.
-	  * @param name The name of the metadata as a <strong>String</strong>.
-	  * @param language The <strong>Language</strong> to use.
-	  * @param value The value of the metadata also as a <strong>String</strong>.
-	  */
-    public void setMetadata(String name, Language language, String value) {
-	addMetadata(new CollectionMeta(manager, name, language, value));
-    }
-    /** Method to produce the list of metadata in a string such as you would find in the collection configuration file.
-	  * @return A <strong>String</strong> containing the list of collection metadata.
-	  */
-    public String toString() {
-	// We sort the metadata first.
-	ArrayList metadatum = new ArrayList();
-	for(int i = 0; i < size(); i++) {
-	    metadatum.add(get(i));
-	}
-	Collections.sort(metadatum, new CollectionMetaComparator());
-	// Now we print them
-	StringBuffer text = new StringBuffer("");
-	for(int i = 0; i < metadatum.size(); i++) {
-	    CollectionMeta data = (CollectionMeta) metadatum.get(i);
-	    if(data.valid()) {
-		text.append(data.toString());
-	    }
-	}
-	metadatum = null;
-	text.append("\n");
-	return text.toString();
-    }
-    /** Overloaded to call get with both a key and an empty argument array.
-	  * @param key A <strong>String</strong> which is mapped to a initial String within the ResourceBundle.
-	  * @return A <strong>String</strong> which has been referenced by the key String and that either contains no argument fields, or has had the argument fields automatiically populated with formatting Strings of with argument String provided in the get call.
-	  */
-    private String get(String key) {
-	return get(key, null);
-    }
-    /** Used to retrieve a property value from the Locale specific ResourceBundle, based upon the key and arguments supplied. If the key cannot be found or if some other part of the call fails a default (English) error message is returned. <BR>
-	  * Here the get recieves a second argument which is an array of Strings used to populate argument fields, denoted {<I>n</I>}, within the value String returned. Note that argument numbers greater than or equal to 32 are automatically mapped to the formatting String named Farg<I>n</I>.
-	  * @param key A <strong>String</strong> which is mapped to a initial String within the ResourceBundle.
-	  * @param args A <strong>String[]</strong> used to populate argument fields within the complete String.
-	  * @return A <strong>String</strong> which has been referenced by the key String and that either contains no argument fields, or has had the argument fields automatiically populated with formatting Strings of with argument String provided in the get call.
-	  * @see org.greenstone.gatherer.Gatherer
-	  * @see org.greenstone.gatherer.Dictionary
-	  */
-    private String get(String key, String args[]) {
-	if(key.indexOf('.') == -1) {
-	    key = "CDM.CollectionMetaManager." + key;
-	}
-	return gatherer.dictionary.get(key, args);
     }
 
-    private class CollectionMetaComparator
-	implements Comparator {
-	public int compare(Object o1, Object o2) {
-	    String s1 = o1.toString();
-	    String s2 = o2.toString();
-	    if(s1.startsWith(".")) {
-		return 1;
-	    }
-	    else if(s2.startsWith(".")) {
-		return -1;
-	    }
-	    return o1.toString().compareTo(o2.toString());
-	}
-	public boolean equals(Object o2) {
-	    return (compare(this, o2) == 0);
-	}
+    public int size() {
+	return getSize();
     }
 }
